=== debian/changelog ===
slic3r-prusa (2.7.2+dfsg-1build2) noble; urgency=medium

  * No-change rebuild against libopenvdb10.0t64.

 -- Colin Watson <cjwatson@ubuntu.com>  Sun, 14 Apr 2024 19:18:11 +0100

slic3r-prusa (2.7.2+dfsg-1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 19:01:09 +1100

slic3r-prusa (2.7.2+dfsg-1) unstable; urgency=medium

  * [68b95ef] New upstream version 2.7.2+dfsg
  * [60635b5] Refresh patches

 -- Chow Loong Jin <hyperair@debian.org>  Sun, 03 Mar 2024 21:48:12 +0800
