=== debian/tests/control ===
Tests: check-cli
Depends: @
Restrictions: allow-stderr

Tests: check-gui
Depends: @, matchbox-window-manager, wmctrl, xvfb, xauth, locales, scrot
Restrictions: allow-stderr, needs-root
