## slic3r-prusa 2.7.4+dfsg

=== src/libslic3r/CMakeLists.txt ===
--- 
+++ 
@@ -223,6 +223,7 @@
     KDTreeIndirect.hpp
     Layer.cpp
     Layer.hpp
+    LayerRegion.hpp
     LayerRegion.cpp
     libslic3r.h
     "${CMAKE_CURRENT_BINARY_DIR}/libslic3r_version.h"
@@ -445,4 +446,3 @@
     SLA/RasterBase.hpp
     SLA/RasterBase.cpp
     SLA/AGGRaster.hpp
-    SLA/RasterToPolygons.hpp
