=== debian/changelog ===
slic3r-prusa (2.7.4+dfsg-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with opencasacade 7.8.1 (Closes: #1071470) and
    add a versioned B-D on it.

 -- Tobias Frost <tobi@debian.org>  Fri, 24 May 2024 22:12:57 +0200

slic3r-prusa (2.7.4+dfsg-1) unstable; urgency=medium

  * [3cddded] New upstream version 2.7.4+dfsg
  * [199df94] Refresh patches
  * [ddcd399] Update catch2 v3 patch

 -- Chow Loong Jin <hyperair@debian.org>  Thu, 18 Apr 2024 13:26:21 +0800
