=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: slic3r-prusa
 Section: misc
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian 3-D Printing Packages <3dprinter-general@lists.alioth.debian.org>
+Maintainer: Debian 3-D Printing Packages <3dprinter-general@lists.alioth.debian.org>
 Uploaders: Chow Loong Jin <hyperair@debian.org>
 Build-Depends: debhelper-compat (= 12),
                catch2,
@@ -21,11 +20,11 @@
                libheatshrink-dev,
                libnanosvg-dev,
                libnlopt-cxx-dev | libnlopt-dev (<< 2.4.2+dfsg-5~),
-               libocct-data-exchange-dev,
-               libocct-draw-dev,
-               libocct-foundation-dev,
-               libocct-modeling-algorithms-dev,
-               libocct-visualization-dev,
+               libocct-data-exchange-dev (>=7.8.1+dfsg1),
+               libocct-draw-dev (>=7.8.1+dfsg1),
+               libocct-foundation-dev (>=7.8.1+dfsg1),
+               libocct-modeling-algorithms-dev (>=7.8.1+dfsg1),
+               libocct-visualization-dev (>=7.8.1+dfsg1),
                libopenvdb-dev (>= 5.0),
                libopenvdb-tools,
                libpng-dev,
