## slic3r-prusa 2.7.5~rc1+dfsg

=== tests/fff_print/CMakeLists.txt ===
--- 
+++ 
@@ -16,6 +16,7 @@
 	test_gcode_travels.cpp
 	test_gcodefindreplace.cpp
 	test_gcodewriter.cpp
+	test_cancel_object.cpp
     test_layers.cpp
 	test_model.cpp
 	test_multi.cpp
